;
; IDL Event Callback Procedures
; MSP_BDP_Status_Table_GUI_eventcb
;
; Generated on:	10/22/2007 11:07.19
;
; Empty stub procedure used for autoloading.
;
pro Dialog_Table_Window_eventcb
end
;
;-----------------------------------------------------------------
pro Dialog_Table_PostCreation, wWidget, _EXTRA=DTW_struct_ptr
    ;
    DTW_ptr =DTW_struct_ptr.ptr
    ;
    (*DTW_ptr).widget_wid = wWidget
    ;
    ;	change font, if selected
    ;
    if((*DTW_ptr).font ne '' and (*DTW_ptr).font ne 'None') then WIDGET_CONTROL, DEFAULT_FONT=(*DTW_ptr).font
    ;
    ;	attach pointer to wWidget
    ;
    WIDGET_CONTROL, wWidget, SET_UVALUE=DTW_ptr	; save the pointer only
    ;
end
;-----------------------------------------------------------------
;
pro Dialog_Table_Realize, wWidget
	;
	color_names = ["black", "white", "red", "orange", "yellow", "green", "blue", "violet", "gray"]
	color_rgb =  [ [0,        255,     255,     255,    255,        50,      0,       148,    220], $
              	  [0,        255,       0,     165,    255,       205,      0,         0,    220], $
                  [0,        255,       0,       0,      0,        50,    255,       211,    220]]
    ;
	WIDGET_CONTROL, wWidget, GET_UVALUE=DTW_ptr
    ;
    ;	now, all the widgets are realized, so update the missing ones
    ;
    label_wid = WIDGET_INFO( wWidget, FIND_BY_UNAME="Dialog_Table_Top_Text_Line")
    title_wid = WIDGET_INFO( wWidget, FIND_BY_UNAME="Dialog_Table_Base")
    table_wid = WIDGET_INFO( wWidget, FIND_BY_UNAME="Dialog_Table_Table")
    ;
    (*DTW_ptr).label_wid = label_wid
    (*DTW_ptr).table_wid = table_wid
    (*DTW_ptr).title_wid = title_wid
    ;
    ;xsize = (*DTW_ptr).xsize
    ;ysize = (*DTW_ptr).ysize
    ;scr_xsize = (*DTW_ptr).scr_xsize
    ;scr_ysize = (*DTW_ptr).scr_ysize
    ;x_scroll_size = (*DTW_ptr).x_scroll_size
    ;y_scroll_size = (*DTW_ptr).y_scroll_size
    ;
    ;   try to move the pop up window to right hand side of display
	;
	WIDGET_CONTROL, wWidget, XOFFSET=500     ; pixels
	;
	;	change the title and label fields
	;
	if((*DTW_ptr).do_title ne 0) then WIDGET_CONTROL, title_wid, $
					BASE_SET_TITLE=(*DTW_ptr).title
	;
	if((*DTW_ptr).do_label ne 0) then WIDGET_CONTROL, label_wid, $
					SET_VALUE=(*DTW_ptr).label
	;
	;	and set to proper row, column numbers
	;
	;	first, determine if regular array or vector of structures?
	;
	type_code = SIZE((*DTW_ptr).data_array,/TYPE)
	if(type_code eq 8) then begin
		;
		;	is a structure, determine size
		;
		nc = N_TAGS((*DTW_ptr).data_array)
		nr = N_ELEMENTS((*DTW_ptr).data_array)
	endif else begin
		;
		;	is a regular array
		;
		d_size = SIZE((*DTW_ptr).data_array)
		nc = d_size[1]
		nr = d_size[2]
	endelse
	;
	;	set size of BASE
	;
	;WIDGET_CONTROL, title_wid, XSIZE=scr_xsize, YSIZE=scr_ysize
	;
	WIDGET_CONTROL, table_wid, TABLE_XSIZE=nc, TABLE_YSIZE=nr
	;, $
	;	X_SCROLL_SIZE=x_scroll_size, Y_SCROLL_SIZE=y_scroll_size, $
	;,	XSIZE=xsize, YSIZE=ysize
	;
	;	load the column headings
	;
	WIDGET_CONTROL, table_wid, COLUMN_LABELS = (*DTW_ptr).col_headers, $
							   ROW_LABELS = (*DTW_ptr).row_headers
	;	and column widths and alignment
	;
	column_widths = intarr(nc)
	column_widths = 15 + STRLEN( (*DTW_ptr).col_headers )*8
	WIDGET_CONTROL, table_wid, COLUMN_WIDTHS=column_widths, ALIGNMENT=1
	;
	;	then set colors
	;
	;WIDGET_CONTROL, table_wid, EDITABLE=1
	;
	color_array = (*DTW_ptr).color_array
	;
	;print, "color_array = ", color_array
	;
	if(N_ELEMENTS((*DTW_ptr).color_array) eq 1) then begin
		WIDGET_CONTROL, table_wid, BACKGROUND_COLOR = REFORM(color_rgb[WHERE(color_names[*] eq color_array),*])
	endif else begin
		;
		;	must set each cell independently
		;
		for ic = 0, nc-1 do begin
			for ir = 0, nr-1 do begin
				rgb = REFORM(color_rgb[WHERE(color_names[*] eq color_array[ic,ir]),*])
				WIDGET_CONTROL, table_wid, USE_TABLE_SELECT=[ic,ir,ic,ir] , $
						BACKGROUND_COLOR=rgb, ALIGNMENT=1
				;
				;print, "(ic,ir) = ",ic, ir," color = ",color_array[ic,ir], " rgb = ",rgb
				;
			endfor
		endfor
	endelse
	;
	;	and load the data
	;
	WIDGET_CONTROL, table_wid, SET_VALUE=(*DTW_ptr).data_array
    ;
    WIDGET_CONTROL, wWidget, SET_UVALUE=DTW_ptr
    ;
end
;
;---------------------------------------------------------------
;
pro Dialog_Table_Close_Asserted, Event
	;
    ;
    PU_ID = WIDGET_INFO (Event.top, FIND_BY_UNAME="Dialog_Table_Close_Button")
    ;
    w_id = Event.top
    WIDGET_CONTROL, w_id, GET_UVALUE=DTW_ptr
    ;
    ;help, DTW_ptr
    ;help, *DTW_ptr,/structure
    ;
    ;	set title, label wids to zero to signify closure, but not table, since
    ;	we still need to fetch data
    ;
    (*DTW_ptr).label_wid = 0
    (*DTW_ptr).title_wid = 0
    ;
    ;	fetch current data from table and put into revised_data_array
    ;
    WIDGET_CONTROL, (*DTW_ptr).table_wid, GET_VALUE=revised_data_array
    ;print, revised_data_array
    (*DTW_ptr).revised_data_array = revised_data_array
    ;
    WIDGET_CONTROL, w_id, /DESTROY
    ;
end
;
;-----------------------------------------------------------------
pro Dialog_Table_Ignore_Edits_Asserted, Event
	;
    ;
    PU_ID = WIDGET_INFO (Event.top, FIND_BY_UNAME="Dialog_Table_Ignore_Button")
    ;
    w_id = Event.top
    WIDGET_CONTROL, w_id, GET_UVALUE=DTW_ptr
    ;
    ;help, DTW_ptr
    ;help, *DTW_ptr,/structure
    ;
    ;	set title, label wids to zero to signify closure, but not table, since
    ;	we still need to fetch data
    ;
    (*DTW_ptr).label_wid = 0
    (*DTW_ptr).title_wid = 0
    ;
    ;	put current data from table into revised_data_array
    ;
    (*DTW_ptr).revised_data_array = (*DTW_ptr).data_array
    ;
    WIDGET_CONTROL, w_id, /DESTROY
end
