pro P12_init, Event
	;
	;	gets the list of active nights with Step>=8 (LC must be ready
	;	first) onto the P12 list and does all
	;		other initializations
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE = PTR_struct
	s_ptr = PTR_struct.PTR_summary
	b_ptr = PTR_struct.PTR_BPM
	bdf_ptr = PTR_struct.PTR_BDF
	;
	d_wid = (*s_ptr).P12_droplist_night_wid[0]
	;
	num_nights = (*s_ptr).num_nights
	;
	if(num_nights eq 0) then begin
		str_list = ['no nights on list']
	endif else begin
		night_list = (*s_ptr).night_date[0:num_nights-1]
		step_list = (*s_ptr).night_step[0:num_nights-1]
		ind = WHERE(step_list[*] ge 8, count)
		if(count lt 1) then begin
			str_list = ['no nights w/S>=8']
			MSP_BDP_print_text, Event, "No Nights Available for Flat Field Image Creation"$
								+" - Complete Linearity Correction first."
		endif else begin
			;
			;	put into structure array, build string array
			;
			(*bdf_ptr).n_nights = count
			str = strarr(count)
			for i=0, count-1 do begin
				(*bdf_ptr).night_list[i] = night_list[ind[i]]
				str[i] = STRING(format='(I8.8)',night_list[ind[i]])
				;
				;print,"night ",i," desig = ",(*d_ptr).night_list[i]
				;
			endfor
		endelse
	endelse
	;
	WIDGET_CONTROL, (*s_ptr).P12_droplist_night_wid[0], SENSITIVE=1
	WIDGET_CONTROL, d_wid, SET_VALUE=str
	;
	;	clear LED and buttons
	;
	for ib = 0, (N_ELEMENTS( (*s_ptr).P12_LED_wid) - 1) do P12_LED_sensitize, Event, ib, 0
	P12_button_sensitize, Event, 0, 1
	for ib = 0, (N_ELEMENTS((*s_ptr).P12_button_wid) -1)  do P12_button_sensitize, Event, ib, 0
	;
	;	set tab to current
	;
	WIDGET_CONTROL, (*s_ptr).P12_tab_wid, SET_TAB_CURRENT = (*s_ptr).P12_current_tab
	;
	;	clear pol textboxes
	;
	WIDGET_CONTROL, (*s_ptr).P12_text_wid[0],SET_VALUE='0'
	WIDGET_CONTROL, (*s_ptr).P12_text_wid[1],SET_VALUE='  '
	;
	;	desensitize the rollback base
	;
	WIDGET_CONTROL, (*s_ptr).P12_base_wid, SENSITIVE=0
	;
	WIDGET_CONTROL, (*s_ptr).P12_radio_dither_wid, SET_BUTTON = (*s_ptr).P12_zht_dither_flag
	;
	;	load the BDP, Dark, Flat structure
	;
	P12_Load_BPM_List, Event
	P12_Load_Dark_List, Event
	P12_Load_Flat_List, Event
end