function fix_path, in_path
;
;	replaces all the directory delimiters in in_path
;	with the correct ones for this OS
;
;	DPC		20100728
;			20100824 bug fixed
;
save_path = in_path		; don't modify the input directly
;
;	get the string length
;
s_len = STRLEN(save_path)
;
;	and test for leading, following directory marks
;
first_0 = STRPOS(save_path, '/')
if(first_0 gt 0) then first_0 = -1
first_1 = STRPOS(save_path, '\')
if(first_1 gt 0) then first_1 = -1
last_0 = STRPOS(save_path, '/', (s_len-1))
last_1 = STRPOS(save_path, '\', (s_len-1))
;
parts = STRSPLIT(save_path, '\/', COUNT=count, /EXTRACT)	; split on either / or \
;
;	put pathname back together, using new separators
;
new_path = parts[0]
if(count gt 1) then begin
	for i = 1, count-1 do begin
		new_path = new_path + PATH_SEP() + parts[i]
	endfor
endif
;
;	and add leading and/or trailing separators
;
if(first_0 ne -1 or first_1 ne -1) then new_path = PATH_SEP() + new_path
if(last_0 ne -1 or last_1 ne -1) then new_path = new_path + PATH_SEP()
;
return, new_path
end