function kokepeli_sharpen, array, kernel
;
;   does image sharpening with a kernel
;
;   DPC 20050726 original as sharp_test.pro
;       20050727 modified to be function, with input image and kernel
;
;
;   0. get image sizes
;
sz = size(array)
ncol = sz[1]
nrow = sz[2]
;
;   1. compute, remove median filtered mean of image
;
mm = median_remove_image(array)
;
;   2. truncate image values to +/- 10 sigma of mean
;
m_array = truncate(mm)
;
;   3. change deleted data in array to NaN for CONVOL to process correctly
;
for i = 0, nrow-1 do begin
    ind = where(m_array[*,i] eq -1.0d6,bad_count)
    if(bad_count ne 0) then m_array[ind,i] = !VALUES.D_NAN
endfor
;
;   4. do the convolution
;
s = 1.0d0
result = CONVOL(m_array, kernel, s, /NAN)
;
return, result
end

