function safe_math_old, image_a, image_b, bad_pix_image, operation
;
;   does simple math ops (+,-,/,*), but respects bad pixels properly
;
;   if second image is a constant, do constant arith
;
;   DPC 20050923    separated from linearity_correct.pro
;       20051123    modified to fix indexing bug
;       20051210    modified to trap pixels with values *below* bad_pix_value
;		20080117	sped up by simplifying traps and tests
;
bad_pix_value = -1.0e6
bad_band = abs(bad_pix_value)/20.
;
sz = size(image_a)
ncol = sz[1]
nrow = sz[2]
;
nb = N_ELEMENTS(image_b)
if(nb eq 1) then iconst = 1 else iconst = 0
;
result = dblarr(ncol,nrow)
row_result = dblarr(ncol)
;
;	split constant second argument from image second argument to reduce
;	tests
;
if(iconst eq 0) then begin
	for irow = 0, nrow-1 do begin
	    ;
	    ;  find all the bad pixels
	    ;
	    bad_pix_row = reform(bad_pix_image[*,irow])
	    ind_bad = WHERE(bad_pix_row, bad_count)
	    ;
	    row_a = reform(image_a[*,irow])
	    ;
	    ind_bad_a = WHERE(row_a eq bad_pix_value, bad_a_count)
	    ;
        row_b = reform(image_b[*,irow])
        ;
        ind_bad_b = WHERE(row_b eq bad_pix_value, bad_b_count)
        ;
        ;	total index of bad pixels
        ;
        ind_all = 0L
        n_ind = 0
        if(bad_count ne 0) then begin
        	ind_all = ind_bad
        	n_ind = bad_count
        endif
        if(bad_a_count ne 0) then begin
        	if(n_ind eq 0) then begin
        		ind_all = ind_bad_a
        		n_ind = bad_a_count
        	endif else begin
        		ind_all = [ind_all, ind_bad_a]
        		n_ind = n_ind + bad_a_count
        	endelse
        endif
        if(bad_b_count ne 0) then begin
        	if(n_ind eq 0) then begin
        		ind_all = ind_bad_b
        		n_ind = bad_b_count
        	endif else begin
        		ind_all = [ind_all, ind_bad_b]
        		n_ind = n_ind + bad_b_count
        	endelse
        endif
        ;
       	;	and for division, find b image zeros
       	;
       	if(operation eq '/') then begin
            ind_bad_c = WHERE(row_b eq 0.0,bad_c_count)
            if(bad_c_count gt 0) then begin
	            if(n_ind eq 0) then begin
	        		ind_all = ind_bad_c
	        		n_ind = bad_c_count
	        	endif else begin
	        		ind_all = [ind_all, ind_bad_c]
	        		n_ind = n_ind + bad_c_count
	        	endelse
	        endif
       	endif
       	;
       	;	organize all bad pixels into one list
       	;
        if(n_ind ne 0) then begin
        	;
        	;	sort, remove dupes
        	;
        	ind_sort = SORT(ind_all)
        	ind_uniq = UNIQ(ind_all[ind_sort])	; now holds all the bad indices
        	ind_uniq = ind_all[ind_sort[ind_uniq]]
        	;
        	n_ind = N_ELEMENTS(ind_uniq)
        endif
       	;
       	;	force A, B vectors to unity where bad
       	;
       	if(n_ind ne 0) then begin
       		row_a[ind_uniq] = 1.0
       		row_b[ind_uniq] = 1.0
       	endif
	    ;
	    ;  do the math
	    ;
        case operation of
          '+':  row_result = row_a + row_b
          '-':  row_result = row_a - row_b
          '/':  row_result = row_a / row_b
          '*':  row_result = row_a * row_b
          else: begin
		              print,"ERROR no proper operation selected"
		              stop
		        end
        endcase
        ;
        ;	if any deleted, add them back in
        ;
        if(n_ind ne 0) then row_result[ind_uniq] = bad_pix_value
        ;
	    ;   load output array
	    ;
	    result[*,irow] = row_result
	    ;
    endfor
endif else begin
	;
	;	the case for second argument is a constant
	;
	B = image_b
	if(B ne 0) then begin
		;
		for irow = 0, nrow-1 do begin
		    ;
		    ;  find all the bad pixels
		    ;
		    bad_pix_row = reform(bad_pix_image[*,irow])
		    ind_bad = WHERE(bad_pix_row, bad_count)
		    ;
		    row_a = reform(image_a[*,irow])
		    ;
		    ind_bad_a = WHERE(row_a eq bad_pix_value, bad_a_count)
	        ;
	        ;	total index of bad pixels
	        ;
	        ind_all = 0L
	        n_ind = 0
	        if(bad_count ne 0) then begin
	        	ind_all = ind_bad
	        	n_ind = bad_count
	        endif
	        if(bad_a_count ne 0) then begin
	        	if(n_ind eq 0) then begin
	        		ind_all = ind_bad_a
	        		n_ind = bad_a_count
	        	endif else begin
	        		ind_all = [ind_all, ind_bad_a]
	        		n_ind = n_ind + bad_a_count
	        	endelse
	        endif
	       	;
	       	;	organize all bad pixels into one list
	       	;
	        if(n_ind ne 0) then begin
	        	;
	        	;	sort, remove dupes
	        	;
	        	ind_sort = SORT(ind_all)
	        	ind_uniq = UNIQ(ind_all[ind_sort])	; now holds all the bad indices
        		ind_uniq = ind_all[ind_sort[ind_uniq]]
	        	;
	        	n_ind = N_ELEMENTS(ind_uniq)
	        endif
	       	;
	       	;	force A vector to unity where bad
	       	;
	       	if(n_ind ne 0) then begin
	       		row_a[ind_uniq] = 1.0
	       	endif
		    ;
		    ;  do the math
		    ;
	        case operation of
	          '+':  row_result = row_a + B
	          '-':  row_result = row_a - B
	          '/':  row_result = row_a / B
	          '*':  row_result = row_a * B
	          else: begin
			              print,"ERROR no proper operation selected"
			              stop
			        end
	        endcase
	        ;
	        ;	if any deleted, add them back in
	        ;
	        if(n_ind ne 0) then row_result[ind_uniq] = bad_pix_value
	        ;
		    ;   load output array
		    ;
		    result[*,irow] = row_result
		    ;
	    endfor
	endif else begin
		result[*,*] = bad_pix_value
	endelse
    ;
endelse
;
;   trap output so nothing more negative than bad_pix_value is returned
;
ind = WHERE(result[*] le bad_pix_value,count)
if(count gt 0) then result[ind] = bad_pix_value
;
return, result
end